package org.springframework.webflow.samples.phonebook.webflow;

import java.io.ByteArrayOutputStream;
import java.io.ObjectOutputStream;

import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpSessionAttributeListener;
import javax.servlet.http.HttpSessionBindingEvent;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class SessionAttributeListener implements HttpSessionAttributeListener {

	protected final Log logger = LogFactory.getLog(getClass());

	public void attributeAdded(HttpSessionBindingEvent arg0) {
		logger.debug("HttpSession add attribute " + getMessage(arg0));
	}

	public void attributeRemoved(HttpSessionBindingEvent arg0) {
		logger.debug("HttpSession remove attribute " + getMessage(arg0));
	}

	public void attributeReplaced(HttpSessionBindingEvent arg0) {
		logger.debug("HttpSession replace attribute " + getMessage(arg0));
	}
	
	private String getMessage(HttpSessionBindingEvent arg0) {
		
		HttpSession session = arg0.getSession();
		String attr = arg0.getName();

		StringBuilder sb = new StringBuilder();
		try {
			int size = getSerializedSize(session.getAttribute(attr));
			sb.append("'").append(attr).append("'");
			sb.append(", size=").append(size);
			sb.append(", sessionId=").append(session.getId());
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return sb.toString();
	}

	private int getSerializedSize(Object obj) throws Exception {
		
		ByteArrayOutputStream bout = new ByteArrayOutputStream();
		ObjectOutputStream oout = new ObjectOutputStream(bout);
		oout.writeObject(obj);
		oout.flush();
		int objSize = bout.toByteArray().length;
		return objSize;
	}
}
